/*=================================================================================
	icap.c
-----------------------------------------------------------------------------------
	UART̃{[[gʐMɍ킹Ďݒ肷vO
	肩ꕶ'a'MƂ̃X^[grbgACvbgLv`
	{[[gZoBiM镶R[h́A0rbgڂ'1'ł́j
	UARTInputCapture̐ڑ͈ȉ̂ƂłB
	@UART1 <-> InputCapture1,UART2 <-> InputCapture2

	̃{[[gςƂ́AXCb`SW2Ăꕶ'a'MB
	ȂAIC2sɐڑĂXCb`SW3͎gpłȂȂB

	NbN\[X	Fosc = 7.37[MHz] :dsPIC̓NbNgp
	VXeNbNFsy  = 7.37 * 8 = 58.96[MHz] :PLLx8gp
	߃NbN	Fcy  = 58.96 / 4 = 14.74[MHz]
=================================================================================*/
#include <p30f5011.h>	//TRISB̓@\WX^gp邽߂ɌĂяo
#include "lcd.h"		//wait֐сALCD֘Å֐gp邽߂ɌĂяo
#include "uart.h"		//uartini֐gp邽߂ɌĂяo

//Configuration bits (dsPIC̊{ݒ)----------------------------------------------
_FOSC(CSW_FSCM_OFF & FRC_PLL8);		//RCiNbNj8{, NbNj^[OFF
_FWDT(WDT_OFF);						//EHb`hbO^C}[OFF
_FBORPOR(PBOR_OFF & MCLR_EN);		//uEAEgZbgOFF, }X^[NAL
_FGS(CODE_PROT_OFF);				//R[hیOFF
//----------------------------------------------------------------------------------------
#define CR	 0x0D		//sCR
#define LF	 0x0A		//sLF
#define NULL 0x00		//NULL0x00Ƃ
#define Fcy 14740000	//߃TCNNbNF14.74MHz

char lcddata[12];		//LCDf[^obt@
int	edge_detect=0;		//GbWo
unsigned int buf_rise=0;	//オGbWoTMRl
unsigned int buf_fall=0;	//GbWoTMRl
char RxValue='@';			//M
char pre_RxValue='@';		//ȑOɑM

int main(void)
{
	unsigned long br=0;		//{[[g230400bps < 2^32-1
	int indata;				//̓|[gpf[^ۑϐ

	TRISB = 0xffc0;			//RB5-RB0:o,RB8:
	TRISD = 0xff00;			//RD7-RD0:o,RD11-RD8:

	SR = ((SR & 0xff1f) | 0x0020);	//MPU荞ݗDx1ɐݒ
	INTCON1 = 0x8000;				//d荞݋֎~
	INTCON2 = 0x0000;				//IVTgp

	IPC1 = ((IPC1 & 0xfff8) | 0x0006);	//IC2荞ݗDx6ɐݒ
	IFS0 = (IFS0 & 0xffef);				//IC2荞݃tONA
	IEC0 = ((IEC0 & 0xffef) | 0x0010);	//IC2荞݋

	IC2CON = 0x0081;	//TIMER2gpALv`ƂɊ݁ASẴGbWŃLv`
	T2CON = 0x8000;		//^C}2 ON
	TMR2 = 0x0000;		//^C}2WX^NA

	uartini();			//UART̏
	InitLCD();			//LCD̏

	PrintLCD("Auto Baud Rate\n");	//LCDbZ[W

	while(1){
		if(edge_detect==2){
			IC2CON = 0x0000;	//IC2~
			T2CON = 0x0000;		//^C}2 OFF
			TMR2 = 0x0000;		//^C}2WX^NA
			edge_detect = 0;	//GbWo񐔂NA

			wait(100);	//100ms҂

			uartini();			//UARTɂobt@A荞݃tONA
			U2BRG = ((buf_rise - buf_fall)/16) - 1;	//{[[gݒ
			IEC1 = ((IEC1 & 0xfeff)|0x0100);		//UART2M݋

			br = Fcy/(buf_rise - buf_fall);			//{[[g

			lcddata[0] = '0' + br % 1000000 / 100000;	//10i6
			lcddata[1] = '0' + br % 100000 / 10000;		//10i5
			lcddata[2] = '0' + br % 10000 / 1000;		//10i4
			lcddata[3] = '0' + br % 1000 / 100;			//10i3
			lcddata[4] = '0' + br % 100 / 10;			//10i2
			lcddata[5] = '0' + br % 10;					//10i1
			lcddata[6] = '[';
			lcddata[7] = 'b';
			lcddata[8] = 'p';
			lcddata[9] = 's';
			lcddata[10] = ']';
			lcddata[11] = NULL;	//̏I[NULL
			PrintLCD(lcddata);	//LCDlcddata̓eibr̒ljo
			LocateLCD(0,1);		//LCD2sڂ̐擪ɃJ[\߂

			PORTD = 0x0001;		//LED1_
		}

		indata = PORTD; 		//RD11-RD8̓͂indataɕۑ
		if(!(indata&0x0100)){	//RD8ɐڑꂽXCb`SW2ꂽ
			PORTD = 0x0000;		//LED1
			IC2CON = 0x0081;	//IC2ċN
			T2CON = 0x8000;		//^C}2 ON
			IEC1 = IEC1 & 0xfeff;	//UART2M݋֎~
		}
	}
	return 0;
}

/* InputCapture荞ݏ */
void __attribute__((interrupt)) _IC2Interrupt(void)
{
	IFS0 = (IFS0 & 0xffef);	//InputCapture2荞݃tONA

	edge_detect++;			//GbWo񐔂CNg

	switch(edge_detect){
		case 1:	buf_fall = IC2BUF;	//GbWoTMRlobt@Ǐo
				break;
		case 2:	buf_rise = IC2BUF;	//オGbWoTMRlobt@Ǐo
				break;
		default:break;
	}
}

/* UARTM荞ݏ */
void __attribute__((__interrupt__)) _U2RXInterrupt(void)
{
	IFS1 = IFS1 & 0xfeff;		//UART2M݃tONA
	pre_RxValue = RxValue;		//O̎Mf[^i[
	RxValue = U2RXREG;	//MWX^̓ei[

	U2TXREG = pre_RxValue;		//ύXO̎Mf[^𑗐M
	while(!(U2STA & 0x0100));	//MWX^ɂȂ܂ňꎞ~

	/*  */
	U2TXREG = '=';				//''𑗐M
	while(!(U2STA & 0x0100));	//MWX^ɂȂ܂ňꎞ~
	U2TXREG = '>';				//'>'𑗐M
	while(!(U2STA & 0x0100));	//MWX^ɂȂ܂ňꎞ~

	U2TXREG = RxValue;			//ύX̎Mf[^𑗐M
	while(!(U2STA & 0x0100));	//MWX^ɂȂ܂ňꎞ~

	/* s */
	U2TXREG = CR;				//CR𑗐M
	while(!(U2STA & 0x0100));	//MWX^ɂȂ܂ňꎞ~
	U2TXREG = LF;				//LF𑗐M
	while(!(U2STA & 0x0100));	//MWX^ɂȂ܂ňꎞ~
}
